#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define str string
#define ldb long double
#define ll long long
#define db double
#define ull unsigned long long
#define ss second
#define ff first
#define pob pop_back
#define pub push_back
#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define all(v) v.begin(), v.end()
const ll INF18 = 2e18;
const int INF9 = 2e9;
const db PI = acos(-1);
const db EPS = 1e-5;
mt19937 rnd(time(0));
template <typename T, typename TT>
ostream& operator<<(ostream& out, pair<T, TT> &a) {
    out << "{" << a.ff << ' ' << a.ss << '\n';
    return out;
}
template <typename T>
ostream& operator<<(ostream& out, vector<T> &a) {
    for (auto it : a)
        out << it << ' ';
    return out;
}
template <typename T>
ostream& operator<<(ostream& out, set<T> &a) {
    for (auto it : a)
        out << it << ' ';
    return out;
}
#define print(...) cout << #__VA_ARGS__ << " = " << __VA_ARGS__ << '\n'
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>
#define int ll

#define db long double

db binpow(db a, int n) {
    if (n == 0) {
        return 1;
    }
    if (n % 2) {
        return binpow(a, n - 1) * a;
    }
    db ans = binpow(a, n / 2);
    return ans * ans;
}

signed main() {
    fast

    int n, m;
    cin >> n >> m;

    db r;
    cin >> r;

    vector<pair<int, int> > dv(n);
    for (int i = 0; i < n; i++) {
        cin >> dv[i].ff >> dv[i].ss;
    }

    sort(all(dv));

    vector<int> q(m);
    for (int i = 0; i < m; i++) {
        cin >> q[i];
    }
    sort(all(q));

    int i = 0, j = 0;
    int pr = -1;
    db waste = 0;
    while (j < m) {
        while (i < n && j < m && dv[i].ff <= q[j]) {
            if (pr == -1) {
                waste = dv[i].ss * r;
            } else {
                waste = waste * binpow((db)1.0f - r, dv[i].ff - pr) + dv[i].ss * r;
            }
            pr = dv[i].ff;
            i++;
        }
        if (pr == -1) {
             cout << fixed << setprecision(6) << 0 << ' ';
        } else {
             cout << fixed << setprecision(6) << (waste * binpow((db)1.0f - r, q[j] - pr)) << ' ';
        }
        j++;
    }

    return 0;
}
